'
' -------------------------------------------------------------------
' FbToRqInc     Functions.Inc       June 6th, 2006         by Jacques
' -------------------------------------------------------------------
'
Sub Wait (duration As Single)
    DefSng sngStart
    sngStart = Timer
    Do
        DoEvents
    Loop Until Abs(Timer - sngStart) > duration
End Sub
'
Sub ShellRedirCallBack (Text As String)  ' UnUsed necessary for shellredir 
End Sub
'
Sub DeletePreviousFiles
    DefStr sSaved
    DefInt N
    Kill "Temp.Asm"
    Kill "Temp.Nasm"
    Kill "Temp.Inc"
    N = 1
    MkDir "BackUpToDelete"
    sSaved = "BackUpToDelete\\" & "Temp_" & Str$(N) & ".Bas"
    While FileExists (sSaved) = 1
        Inc N
        sSaved = "BackUpToDelete\\" & "Temp_" & Str$(N) & ".Bas"
    Wend
    If FileExists ("Temp.Bas") = 1 Then Rename "Temp.Bas", sSaved
    While FileExists("Temp.Asm") = 1
        DoEvents
    Wend
    While FileExists("Temp.Nasm") = 1
        DoEvents
    Wend
    While FileExists("Temp.Inc") = 1
        DoEvents
    Wend
End Sub

Function FbCompileToAsm () As String
    DefStr sBas, sShell, sFbOutput, sTmp
    DefInt iRet
    DeletePreviousFiles
  With rchWin
    ' Auto Add 'Option Explicit'
    If Instr(LCase$(.Line(0)), "option explicit") = 0 Then
        .Line(0) =  "Option Explicit\r\n" & .Line(0)
    End If
    sBas = .Text
    .SaveToFile ("Temp.Bas")
    While FileExists("Temp.Bas") = 0
        DoEvents
    Wend
    sShell = "FBC -r Temp.Bas"
    ' iRet = Shell (sShell, 0)
    sFbOutPut = ShellRedir (sShell)
    ' Error as.exe not found ... occures when trying to compile to exe, we have the .asm
    ' this FB error means all OK on .Asm side.
    If (Len(sFbOUtPut) < 100 And  Instr(sFBOutput,"bin\\win32\\as.exe") > 70) Then
        sFBOutput = "  ***  FB COMPILED TO .ASM OK  ***   (no exe created)"
        Result = ""
    Else
        Result = sFBOutput
    End If
    While FileExists("Temp.Asm") = 0
        DoEvents
    Wend
'
    sTmp = "___COMPILED FREEBASIC ASM FILE: Temp.Bas___"
    sAll = sAll & "\n\n\n\n" & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & sFbOutput
'
    .LoadFromFile ("Temp.Asm")
    .AddString sFBOutPut
    DoEvents
  End With
End Function
'
Function ExtractNextAsmFunction () As String
    DefStr sLine, sAsmFunc = "", sOut, sTmp
  With rchWin
    ' Search .globl
    While Left$(LCase$(.Line(iScanAsmLine)), 7) <>  ".globl "
        Inc iScanAsmLine
        If iScanAsmLine >= .LineCount Then
            Result = ""
            Exit Function
        End If
    Wend
    sFuncName = Mid$(Field$(.Line(iScanAsmLine), " ", 2), 2)
    iArgNumber = Val(Field$(sFuncName, "@", 2))/4
    sFuncName = Val(Field$(sFuncName, "@", 1))/4
    If LCase$(sFuncName) = "main" Then
        Result = ""
        Exit Function
    End If
    IscanAsmLine = IScanAsmLine + 2           ' skip 2 first lines
    ' Grab Asm Lines Until .balign is found
    While Left$(LCase$(.Line(iScanAsmLine)), 8) <>  ".balign "
        sAsmFunc = sAsmFunc & .Line(iScanAsmLine) & "\r\n"
        Inc iScanAsmLine
        If iScanAsmLine >= .LineCount Then
            Result = ""
            Exit Function
        End If
    Wend
    Inc iScanAsmLine
    Result = sAsmFunc
    sOut = "EXTRACTED ASM: " & sFuncName _
    & "\n\n; ----------------------------------------" _
      & "\n; Function Name: " & sFuncName _
      & "\n; Arg Number: "  & Str$(iArgNumber) _
      & "\n; ----------------------------" _
      & "\n" & sAsmFunc _
      &   "; ----------------------------------------"
'
    sTmp = "___EXTRACTED FREEBASIC ASM FUNCTION: " & sFuncName & " ___"
    sAll = sAll & "\n\n\n\n" & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & sOut
'
    If flagShowMessages = 1 Then ShowMessage sOut
  End with
End Function
'
Function TranslateASMtoNASM (sAsm as string) As String
    Dim fileNasm As QFileStream
    DefStr sWord, sNasm = "", sFile, sTmp
    DefInt iLine
    Dim lstAsm As QStringList
    lstAsm.Text = sAsm
  With lstAsm
    For iLine = 0 To .ItemCount - 1
        If UCase$(Left$(.Item(iLine), 1)) = "J" Then
            sWord = Left$(.Item(iLine), Instr(.Item(iLine), " "))
            If Instr ("JA JAE JB JBE JC JCXZ JE JG JGE JL JLE JNA JNE JNB JNBE JNC JNE JNG JNGE JNL JNLE JNO JNP JNS JNZ JO JP JPE  JPO JS JZ ", Ucase$(sWord)) <> 0 Then
                .Item(iLine) = ReplaceSubstr$(.Item(iLine), sWord, sWord & "near ")
            End If
        End If
        sNasm = sNasm & "\n" & .Item(iLine)
    Next iLine
    sNasm = ReplaceSubStr$ (sNasm, " ptr", "")
    sTmp =  "; ---- Start Nasm Function : " & sFuncName & " ----"
    sNasm = sTmp & String$(60 - Len(sTmp), "-") _
        & "\n; " & Date$  & " by FBtoRQINC extracted from:  " & sSelFile _
        & "\n; Argument Number: " & Str$(iArgNumber) _
        & "\n; Compile me : Nasmw.exe " & sFuncName & ".Nasm -fbin -o " & sFuncName & ".Bin" _
        & "\n; " & String$(58, "-") _
        & "\n    bits 32" _
        & "\n    segment .text" _
        & "\n    " & sFuncName _
        & "\n; -------------" _
        & sNasm
    sTmp = "; ---- End Nasm Function " & sFuncName & " ----"
    sNasm = sNasm & "\n" & sTmp & String$(60 - Len(sTmp), "-")
    sNasm = ReplaceSubStr$(sNasm, Chr$(10), Chr$(13) & Chr$(10))
  End With
    sFile = sFuncName & ".Nasm"
    While FileExists (sFile) = 1
        Kill sFile
        DoEvents
    Wend
    fileNasm.Open (sFile, fmCreate)
        fileNasm.WriteBinStr (sNasm, Len(sNasm))
    fileNasm.Close
    While FileExists (sFile) = 0
        DoEvents
    Wend
'
    sTmp = "___FREEBASIC ASM TRANSLATED TO NASM: " & sFuncName & " ___"
    sAll = sAll & "\n\n\n\n" & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & sNasm
'
    If flagShowMessages = 1 Then ShowMessage ("NASM:  " & sFile & "\n\n" & sNasm)
End function
'
Function NasmToBin () As String
    DefStr sShell, sTmp
    DefInt iRet, iWso, iOPenCount
    Dim fileDump As QFileStream
    sShell = "Nasmw.exe " & sFuncName & ".Nasm -fbin -EASM.$$$ -o " & sFuncName & ".Bin"            
    iRet = Shell (sShell, 0)  
    ' Check if Compile OK ....
    If iRet = 0 Then
        ' ShowMessage "ERROR NASMW COMPILE TO BIN FAILED\n\nNOTHING DONE RETRY"
        Result = "ERROR NASMW COMPILE TO BIN FAILED\n\nNOTHING DONE RETRY"
        Exit Function
    End If
    iWso = WaitForSingleObject (iRet, 5000)
    If iWso = 0 Then
        ' Open Dump File
        iOpenCount = 0
        While fileDump.Open ( "ASM.$$$", fmOpenRead) = 0
            iOpenCount ++
            Wait (0.1)
            If (iOpenCount > 40) Then
                ' ShowMessage "ERROR: CANNOT OPEN  ASM.$$$  AFTER 4 SECONDS\n\nI STOP, RETRY"
                Result = "ERROR: CANNOT OPEN  ASM.$$$  AFTER 4 SECONDS\n\nI STOP, RETRY"
                Exit Function
            End If
        Wend
        If fileDump.Size = 0 Then
            ' ShowMessage ("OK \"" & sFuncName & "\"  COMPILED TO " & sFuncName & ".Bin\n")
            Result = ""
        Else
            sTmp = "ERROR WHILE COMPILING  \"" & sFuncName & "\"  TO BIN"
            sTmp = sTmp +   "\n\n    ---- START NASMW COMPILATION TO BIN ERROR(S)"
            fileDump.Position = 0
            While fileDump.Eof = 0
                sTmp = sTmp & "\n       " & fileDump.ReadLine
            Wend
            sTmp = sTmp +     "\n    ---- END NASM COMPILATION TO BIN ERRORS\n"
            ' ShowMessage sTmp
            Result = sTmp
        End If
        fileDump.Close
    Else
        ' ShowMessage ("WAITFORSINGLEOBJECT TIMOUT WHILE COMPILING  "& sFuncName & ".Asm  to  BIN\n\nI STOP, RETRY")
        Result = "WAITFORSINGLEOBJECT TIMOUT WHILE COMPILING  "& sFuncName & ".Asm  to  BIN\n\nI STOP, RETRY"
    End If
End Function
'
Sub BintoRQInc
    DefStr sInc, sTmp, binStringed, ArrayName, sFile
    DefInt N, P, binStringedSize
    Dim fileBin as QFileStream
    Dim fileInc as QFileStream
    sInc = "' " & String$(78, "=")  
    sInc = sInc & "\nDECLARE FUNCTION " & sFuncName _
                & " LIB \"user32\" ALIAS \"CallWindowProcA\" ( _\n          ptr" _
                & sFuncName & " As Long"
    For N = 1 To iArgNumber
        sInc = sInc & ", Arg" & Str$(N) & " As Long"
        If N Mod 4 = 0 Then sInc = sInc & " _\n          "
    Next N
    sInc = sInc & ") As Long\n"
    ' Load Assembly Code In a String
    ArrayName = "Array" & sFuncName
    fileBin.Open (sFuncName & ".Bin", fmOpenRead)
         binStringedSize = fileBin.Size
         binStringed = fileBin.ReadBinStr(binStringedSize)
    fileBin.Close
    ' Array
    sTmp = "' ----- START ASM " & sFuncName & " -----\nDefByte " & arrayName _
                        & " (0 To " & Str$(binStringedSize - 1) & ") = _\n   {"
    sInc = sInc + sTmp
    P = 0
    For N = 1 To binStringedSize
        If P = MAX_HEX_PER_LINE Then
            P = 0
            sInc = sInc + " _\n    "
        End If    
        sInc = sInc + "&H" & Right$ (Hex$ (Asc (binStringed[N]) ), 2)
        If N <> binStringedSize Then
            sInc = sInc + ", "
            Inc P
        End If
    Next N
    sTmp = 
    sInc = sInc + "}\n' ----- END ASM " & sFuncName & " -----"
    ' Pointer
    sInc = sInc + "\nDefInt ptr" & sFuncName & " = VarPtr (" & ArrayName & "(0))"
    sInc = sInc & "\n' CALL ME WITH: iRet = " & sFuncName & "(ptr" & sFuncName
    If iArgNumber > 0 Then
        sInc = sInc & ", "
        For N = 1 To iArgNumber
            sInc = sInc & "Arg" & Str$(N)
            If N <> iArgNumber Then
                sInc = sInc & ", "
            End If
        Next N
    End If
    sInc = sInc & ")" 
    sInc = sInc & "\n' " & String$(78, "=") 
    sInc = ReplaceSubStr$(sInc, Chr$(10), Chr$(13) & Chr$(10))
    sFile = sFuncName & ".Inc"
    fileInc.Open (sFile, fmCreate)
        fileInc.WriteBinStr (sInc, Len(sInc))
    fileInc.Close
    sAllInc = sAllInc & sInc & "\n\n"
'
    sTmp = "___RAPIDQ INC FILE: " & sFuncName & " ___"
    sAll = sAll & "\n\n\n\n" & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & sInc
'
    If flagShowMessages = 1 Then ShowMessage ("INC: " & sFuncName & "\n\n" & sInc)
End Sub
'
