'
' -------------------------------------------------------------------
' FbToRqInc        Menu.Inc      June 6th, 2006            by Jacques
' -------------------------------------------------------------------
'
Sub OnClic_AnyMenu (Sender)
  With rchWin
    DefStr sAsm = "", sTmp = "", sInc = "", sTmp2, sOldDir
    DefInt N, P, iBeg, iEnd, iLine, iTmp, iRet
    Dim fileTmp As QFileStream
    Dim SaveDialog AS QSaveDialog
    If flagMenuBusy = True Then Exit Sub
    flagMenuBusy = true
    Select Case Sender.Handle
        Case mnuFBBAStoFBASM.Handle
            sAll = ""
            sAllInc = ""
            sTmp = "___LOADED FREEBASIC BAS FILE: " & sSelFile & "___"
            sAll = & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & .Text
            '
            sTmp = FbCompileToAsm
            If sTmp <> "" Then
                sAll = sAll & "\n\nEXIT ON FBC ERROR:\n" & sTmp
                ShowMessage (sTmp)
                flagMenuBusy = False
                Exit Sub
            End If
        Case mnuFBBAStoRQINC.Handle
            sAll = ""
            sAllInc = ""
            sTmp = "___LOADED FREEBASIC BAS FILE: " & sSelFile & "___"
            sAll = & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & .Text
            '
            sTmp = FbCompileToAsm
            If sTmp <> "" Then
                sAll = sAll & "\n\nEXIT ON FBC ERROR:\n" & sTmp
                ShowMessage (sTmp)
                flagMenuBusy = False
                Exit Sub
            End If
            '
            iSCanAsmLine = 0
            sAsm =  ExtractNextAsmFunction
            While sASm <> ""
                TranslateASMtoNASM (sAsm)
                sTmp = NasmToBin
                If sTmp <> "" Then
                    ShowMessage (sTmp)
                    sAll = sAll & "\n\nEXIT ON NASMW ERROR:\n" & sTmp
                    flagMenuBusy = False
                    Exit Sub
                End If
                BintoRqInc
                sAsm = ExtractNextAsmFunction
            Wend
            .Text = sAllInc
            fileTmp.Open ("All.Out", fmCreate)
                fileTmp.WriteBinStr (sAll, Len(sAll))
            fileTmp.Close
            fileTmp.Open ("AllInc.Out", fmCreate)
                fileTmp.WriteBinStr (sAllInc, Len(sAllInc))
            fileTmp.Close
        Case mnuSelAsm.Handle
            DeletePreviousFiles
            sAll = ""
            sAllInc = ""
            sTmp = "___LOADED FREEBASIC ASM FILE: " & sSelFile & "___"
            sAll = sAll & sTmp & "\n\n\n" & String$(Len(sTmp), "*") & "\n" & .Text
'
            iBeg = FBASM_SendMessageX (.Handle, EM_EXLINEFROMCHAR, 0, .SelStart)
            iEnd = FBASM_SendMessageX (.Handle, EM_EXLINEFROMCHAR, 0, .SelStart + .SelLength - 1)
            For iLine = iBeg To iEnd
                sAsm = sAsm & .Line(iLine) & "\n"
            Next iLine
            For iLine = 1 To 5
                iTmp = iBeg - iLine
                If iTmp > 0 Then           '  .globl _MIXSORT@24
                    If Ucase$(Left$(.Line(iTmp), 7)) = ".GLOBL " Then
                        sFuncName = Field$(.Line(iTmp), " ", 2)
                        iArgNumber = Val(Field$(sFuncName, "@", 2))/4
                        sFuncName = Mid$(Field$(sFuncName, "@", 1), 2) ' reject the underscore '_' header
                        iLine = 5 ' = Exit For
                    End If
                Else
                    ShowMessage ("CANNOT FIND FUNCTION NAME\n\n IN THE 5 PREVIOUS LINES\n\nBEFORE SELECTION\n\nNOTHING DONE")
                    flagMenuBusy = False
                    Exit Sub
                End If
            Next N
            sAsm = ReplaceSubStr$(sAsm, Chr$(10), Chr$(13) & Chr$(10))
            If Instr (sAsm, ".globl ") <> 0 Then
                ShowMessage ("YOU PROBABLY SELECT MORE THAN ONE FUNCTION\n\n\".globl \"  WAS FOUND IN THE SELECTION\n\nNOTHING DONE, RETRY" )
                flagMenuBusy = False
                Exit Sub
            End If
'
            sTmp2 =    ("EXTRACTED ASM: " & sFuncName _
                 &  "\n\n; ----------------------------------------" _
                    & "\n; Function Name: " & sFuncName _
                    & "\n; Arg Number: "  & Str$(iArgNumber) _
                    & "\n; ----------------------------" _
                    & "\n" & sAsm _
                    &   "; ----------------------------------------")
            If flagShowMessages = 1 Then ShowMessage sTmp2
'
            sTmp = "___SELECTED FREEBASIC ASM FUNCTION: " & sFuncName & " ___"
            sAll = sAll & "\n\n\n\n" & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & sTmp2
'
            TranslateASMtoNASM (sAsm)
            sTmp = NasmToBin
            If sTmp <> "" Then
                ShowMessage (sTmp)
                flagMenuBusy = False
                Exit Sub
            End If
            BintoRqInc
            .Text = sAllInc
'            ClipBoard.Open
'                ClipBoard.Text = sAllInc
'            ClipBoard.Close
            fileTmp.Open ("All.Out", fmCreate)
                fileTmp.WriteBinStr (sAll, Len(sAll))
            fileTmp.Close
            fileTmp.Open ("AllInc.Out", fmCreate)
                fileTmp.WriteBinStr (sAllInc, Len(sAllInc))
            fileTmp.Close
            ShowMessage ("THE CONTENT OF THIS RICHTEXT WINDOW WAS\n\nSAVED AS \"" & sFuncName & ".Inc\"\n\nFINISHED, READY FOR A NEW TRANSLATION")
        Case mnuHelpCompSel.Handle
            rchDoc.Text = sHelpCompileSelection
            rchDoc.Visible = True
        Case mnuHelpCompFBBAS.Handle
            rchDoc.Text = sHelpCompileFBBAS
            rchDoc.Visible = True
' FILE
        Case mnuNew.Handle, mnuNewDir.Handle
            SaveDialog.Filter = "FREEBASIC FILES|*.Bas;*.Asm|All Files|*.*"
            SaveDialog.FilterIndex = 1
            SaveDialog.InitialDir = sSelPath
            If SaveDialog.Execute Then
                fileTmp.Open (SaveDialog.FileName, fmCreate)
                fileTmp.Close
                ShowMessage (" You must now select\n\n \"" & SaveDialog.FileName & "\"\n\n in the DirBox and FileListBox to avoid\n\n erroneous directory use (will be solved later :)")
            End If
            rchWin.Clear
        Case mnuSaveAs.Handle
            SaveDialog.Filter = "FREEBASIC FILES|*.Bas;*.Asm|All Files|*.*"
            SaveDialog.FilterIndex = 1
            sOldDir = CurDir$
            SaveDialog.InitialDir = sSelPath
            If SaveDialog.Execute Then
                .SaveToFile (SaveDialog.FileName)
            End If
            ChDir sOldDir
' HELP
        Case mnuHelpSelected.Handle 
            frmViewDoc.Visible = True
            frmViewDoc.Show
            MinSet(frmViewDoc.handle, -8, 0, application.handle)
            OleIE.createObject ("Shell.Explorer.1")
            DefStr sFileXX = "command reference.html"
            sTmp = .SelText
            DefStr sUrl = sAppDir & "FbDocHtml\\" & sFileXX & "#" & sTmp
            oleIE.Navigate (sUrl)           
        Case mnuWiki.Handle
            iRet = ShellExecute (frmFBTORQINC.Handle, "Open", "http://www.freebasic.net/wiki/wikka.php?wakka=FBWiki", "", "", 1)
        Case mnuForum.Handle
            iRet = ShellExecute (frmFBTORQINC.Handle, "Open", "http://www.freebasic.net/forum/", "", "", 1)
        Case mnuHelpHelp.Handle
            rchDoc.Text = sHelpHelp
            rchDoc.Visible = True            
    End Select
    flagMenuBusy = False
  End with
End Sub
'
